package yatzy;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * A class holding scores. Each player has a Score (column). In GUI all
 * individual columns are displayed as a table.
 *
 * @author hajo
 */
public class Score {

    /* 
     * The constants below possible are useful elsewhere
     * in application, no hard coded values!!! 
     */
    // Threre are 18 rows in the score board ...
    public static final int N_SCORES = 18;
    // .. they are indexed as ... 
    public static final int ONES = 0;
    public static final int TWOS = 1;
    public static final int THREES = 2;
    public static final int FOURS = 3;
    public static final int FIVES = 4;
    public static final int SIXES = 5;
    public static final int SUM = 6;  // Read only
    public static final int BONUS = 7; // Read only
    public static final int PAIR = 8;
    public static final int TWO_PAIR = 9;
    public static final int THREE_OF_KIND = 10;
    public static final int FOUR_OF_KIND = 11;
    public static final int SMALL_STR = 12;
    public static final int LARGE_STR = 13;
    public static final int HOUSE = 14;
    public static final int CHANS = 15;
    public static final int YATZY = 16;
    public static final int TOTAL = 17; // Read only
    private final List<RowValue> values = new ArrayList<>();

    public Score() {
    }

    public void setScore(int row, int value) {
    }

    public List<RowValue> values() {
        return values;
    }

    public int getSumOneToSix() {
        return 0;
    }

    public int getTotal() {
        return 0;
    }

    @Override
    public String toString() {
        return "Score{" + "values=" + values + '}';
    }

    // ------ Some "non instance" functionality
    public static List<Integer> getPossibilities(List<Integer> result) {
         List<Integer> possibilities = new ArrayList<>();
        
         // Use methods from below here
        possibilities.set(PAIR, getPair(result)); 
         
        return possibilities;
    }

    //-------- All these should be private (public just for testing) -----------------

    
    // This method checks if it's possible to get a pair
    // If so returns the value of the pair else 0
    // Assumes parameter is sorted
    public static int getPair(List<Integer> result) {
        int res = 0;
        for (int i = 0; i < result.size() - 1; i++) {
            if (result.get(i) == result.get(i + 1)) {
                res = result.get(i) + result.get(i + 1);
            }
        }
        return res;
    }
    
    // Many more methods like the one above ... following here
}
