package yatzy.gui;

import java.awt.Color;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;
import javax.swing.BorderFactory;
import javax.swing.JToggleButton;
import javax.swing.JPanel;
import yatzy.EventBus;
import yatzy.Yatzy;

/**
 * Panel to display 5 dice
 * @author hajo
 */
public class DicePanel extends JPanel implements ActionListener, EventBus.IEventHandler {

    private final Yatzy yatzy;
    private final String UNDEFINED = " * ";

    public DicePanel(Yatzy yatzy) {
        this.yatzy = yatzy;
        this.setBorder(BorderFactory.createLineBorder(Color.BLACK));
        for (int i = 0; i < yatzy.getDiceFaces(); i++) {
            JToggleButton b = new JToggleButton(UNDEFINED);
            b.setBackground(GUIOptions.getEnabledColor());
            b.setActionCommand("toggle");
            b.addActionListener(this);
            this.add(b);
        }
        EventBus.INSTANCE.register(this);
    }

    @Override
    public void actionPerformed(ActionEvent e) {
      
    }

    @Override
    public void onEvent(EventBus.Event evt, Object o) {
    
    }

}
