
package yatzy.gui;

import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Font;

/**
 * GUI Options
 *
 * @author hajo
 */
public class GUIOptions {

    private GUIOptions() {
    }
    // User options
    private static Font plainFont = new Font("Helvetica", Font.PLAIN, 12);
    private static Color enabledColor = new Color(222, 250, 207);
    private static Color disabledColor = new Color(250, 220, 230);

    // --------- GUI Options -----------------------
    public static Font getPlainFont() {
        return plainFont;
    }

    public static Color getEnabledColor() {
        return enabledColor;
    }

    public static void setEnabledColor(Color enabledColor) {
        GUIOptions.enabledColor = enabledColor;
    }

    public static Color getDisabledColor() {
        return disabledColor;
    }

    public static void setDisabledColor(Color disabledColor) {
        GUIOptions.disabledColor = disabledColor;
    }

    
    // Used to change font for all components of an JFrame or JPanel.
    // see MainFrame
   /*  public static void setFont(Component component, Font font) {
      
    }*/
}
