package yatzy.gui;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.util.List;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import yatzy.EventBus;
import yatzy.Player;
import yatzy.Score;
import yatzy.RowValue;
import yatzy.Yatzy;

/**
 * Display for the StandardYazy game
 *
 * @author hajo
 */
public class StandardScorePanel extends JPanel implements EventBus.IEventHandler {

    private final Yatzy yatzy;
    private final Table table;
    String labels = ("One,Two,Three,Four,Five,Six,SUM,BONUS,Pair,2 Pair,3 Kind"
            + ",4 Kind,Small Str, Large Str, House,Chance, Yatzy, TOTAL");

    public StandardScorePanel(Yatzy yatzy) {
        this.yatzy = yatzy;
        this.setLayout(new BorderLayout());

        int columns = yatzy.getPlayers().size();
        String[] headers = new String[columns];
        for (int i = 0; i < columns; i++) {
            headers[i] = yatzy.getPlayers().get(i).getName();
        }
        table = new Table(Score.N_SCORES, columns, headers, labels.split(","));
        /*table.setBackground(Color.WHITE);
        table.setEnabledColor(GUIOptions.getEnabledColor());
        table.setDisabledColor(GUIOptions.getDisabledColor());
        this.add(table, BorderLayout.CENTER); // To fill whole area
        */ 
        EventBus.INSTANCE.register(this);
    }

    public void actionPerformed(ActionEvent e) {
       /*
        JTextField t = (JTextField) e.getSource();
        int row = getTable().getRow(t);
        String value = t.getText();
        int v = 0;
        try {
            v = Integer.valueOf(value);
            getYatzy().setScore(row, v);
            getYatzy().next();
        } catch (NumberFormatException ex) {
            JOptionPane.showMessageDialog(this, "Only Numbers Accepted");
            // TODO Clear field
        }*/
    }

    public void enable(int row, int col) {
        //getTable().setCellEnabled(row, col, true);
        //getTable().setCellEditable(row, col, true);
    }

    public void onEvent(EventBus.Event evt, Object o) {
        if (evt == EventBus.Event.ACCEPTED_VALUE) {
            List<RowValue> values = (List<RowValue>) o;
            updateTable(values);
        } else if (evt == EventBus.Event.REJECTED_VALUE) {
            String s = (String) o;
            JOptionPane.showMessageDialog(this, s);
        } else if (evt == EventBus.Event.NEXT_PLAYER) {
            Player p = (Player) o;
            enableColumn(p);
        }
    }

    protected void enableColumn(Player p) {
        table.setEnabled(false);
        for (RowValue v : p.getScoreValues()) {
            if (!v.isSet()) {
                enable(v.getRow(), p.getOrdinal());
            }
        }
    }

    protected void updateTable(List<RowValue> values) {
        Player p = yatzy.getActualPlayer();
        for (RowValue v : values) {
            if (v.isSet()) {
              //  table.setCell(v.getRow(), p.getOrdinal(), String.valueOf(v.getValue()));
            } else {
              //  table.setCell(v.getRow(), p.getOrdinal(), "");
            }
        }
    }
/*
    public Yatzy getYatzy() {
        return yatzy;
    }

    public Table getTable() {
        return table;
    }*/
}
