/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package yatzy.gui.fancy;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JToggleButton;
import javax.swing.Timer;

/**
 * A button with an die animation
 *
 * @author hajo
 */
public class AnimatedDiceButton extends JToggleButton {

    private final ImageIcon ii1; // Animation images
    private final ImageIcon ii2;
    private final Timer timer;
    private final long threshold;
    private ImageIcon staticIcon;
    int toggle = 0;
    private boolean animate;

    public AnimatedDiceButton(int delay, long threshold,
            ImageIcon staticIcon,
            ImageIcon ii1,
            ImageIcon ii2) {
        super.setPreferredSize(new Dimension(staticIcon.getIconHeight(),
                staticIcon.getIconWidth()));
        this.staticIcon = staticIcon;
        this.ii1 = ii1;
        this.ii2 = ii2;
        this.threshold = threshold;
        this.setBorder(BorderFactory.createEmptyBorder());
        timer = new Timer(100, timerListener);
        timer.setDelay(delay);
    }

    public void start() {
        animate = true;
        timer.start();
    }

    public void stop() {
        animate = false;
        timer.stop();
    }

    public boolean isAnimating() {
        return animate;
    }

    public void setStaticIcon(ImageIcon staticIcon) {
        this.staticIcon = staticIcon;
    }

    @Override
    public void paintComponent(Graphics g) {
        // TODO Implement this
    }
    // Callback for timer
    private ActionListener timerListener = new ActionListener() {
        long startTime;

        @Override
        public void actionPerformed(ActionEvent e) {
            if (startTime == 0) {
                startTime = e.getWhen();
            }
            if (e.getWhen() - startTime > threshold) {
                stop();
                startTime = 0;
            }
            repaint();
        }
    };
}
