package yatzy.test;

import java.util.List;
import yatzy.Player;
import yatzy.RowValue;
import yatzy.Score;
import yatzy.YatzyOptions;
import yatzy.io.IYatzyReader;
import yatzy.io.YatzyReaderFactory;

/**
 * Test for the file reader, see main method last To run: Right click in code > Run
 * File
 *
 * @author hajo
 */
public class TestFileReader {

    // Stored file will end up in project directory
    public static void testSave() {
        List<Player> pls = YatzyOptions.getPlayers();
        Player p1 = pls.get(0);
        p1.setScore(Score.ONES, 3);
        p1.setScore(Score.TWOS, 4);
        p1.setScore(Score.PAIR, 10);
        p1.setScore(Score.HOUSE, 12);
        p1.setScore(Score.YATZY, 50);
        Player p2 = pls.get(1);
        p2.setScore(Score.ONES, 3);
        p2.setScore(Score.TWOS, 4);
        p2.setScore(Score.PAIR, 10);
        p2.setScore(Score.HOUSE, 12);
        p2.setScore(Score.YATZY, 50);
        IYatzyReader r = YatzyReaderFactory.getReader();
        r.save("yatzy.txt", pls);
        
    }

    public static void testOpen() {
        IYatzyReader r = YatzyReaderFactory.getReader();
        List<Player> pls = r.open("yatzy.txt");
        for( Player p : pls ){
            System.out.println(p.getName() + ":"  + p.getOrdinal());
            for( RowValue rv :   p.getScoreValues()){
                System.out.print(rv.getRow() + ","  + rv.getValue() + "," + rv.isSet());
            }
            System.out.println();
        }
        
    }

    public static void main(String[] args) {
        //testSave();
        testOpen();
    }
}